'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _UndoButton = require('./UndoButton');

var _UndoButton2 = _interopRequireDefault(_UndoButton);

var _RedoButton = require('./RedoButton');

var _RedoButton2 = _interopRequireDefault(_RedoButton);

var _styles = {
  "button": "draftJsUndoPlugin__button__3Vugn"
};

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultTheme = {
  redo: _styles2.default.button,
  undo: _styles2.default.button
};

exports.default = function () {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var undoContent = config.undoContent ? config.undoContent : '↺';
  var redoContent = config.redoContent ? config.redoContent : '↻';
  var store = {
    getEditorState: undefined,
    setEditorState: undefined
  };

  // Styles are overwritten instead of merged as merging causes a lot of confusion.
  //
  // Why? Because when merging a developer needs to know all of the underlying
  // styles which needs a deep dive into the code. Merging also makes it prone to
  // errors when upgrading as basically every styling change would become a major
  // breaking change. 1px of an increased padding can break a whole layout.
  var theme = config.theme ? config.theme : defaultTheme;
  var DecoratedUndoButton = function DecoratedUndoButton(props) {
    return _react2.default.createElement(
      _UndoButton2.default,
      _extends({}, props, { theme: theme, store: store }),
      undoContent
    );
  };
  var DecoratedRedoButton = function DecoratedRedoButton(props) {
    return _react2.default.createElement(
      _RedoButton2.default,
      _extends({}, props, { theme: theme, store: store }),
      redoContent
    );
  };
  return {
    UndoButton: DecoratedUndoButton,
    RedoButton: DecoratedRedoButton,
    initialize: function initialize(_ref) {
      var getEditorState = _ref.getEditorState,
          setEditorState = _ref.setEditorState;

      store.getEditorState = getEditorState;
      store.setEditorState = setEditorState;
    }
  };
};